global function CocaineMode_Init

void function CocaineMode_Init()
{
	AddCallback_OnClientConnected( PlayerSniffAShot )
	AddCallback_OnPlayerRespawned( PlayerSniffAShot )
	AddSpawnCallback( "npc_titan", NPCSniffAShot )
	AddSpawnCallback( "npc_soldier", NPCSniffAShot )
	AddSpawnCallback( "npc_stalker", NPCSniffAShot )
	AddSpawnCallback( "npc_frag_drone", NPCSniffAShot )
	AddSpawnCallback( "npc_spectre", NPCSniffAShot )
	AddSpawnCallback( "npc_super_spectre", NPCSniffAShot )
	AddSpawnCallback( "npc_prowler", NPCSniffAShot )
}

void function PlayerSniffAShot( entity player )
{
	StatusEffect_AddEndless( player, eStatusEffect.speed_boost, 1.0 )
	thread PlayerConstantRefillEverything( player )
}

void function NPCSniffAShot( entity npc )
{
	StatusEffect_AddEndless( npc, eStatusEffect.speed_boost, 1.0 )
}

void function PlayerConstantRefillEverything( entity player )
{
	player.EndSignal( "OnDeath" )
	player.EndSignal( "OnDestroy" )
	float earnmetertime = Time() + 2.0
	
	while( IsAlive( player ) )
	{
		foreach ( weapon in player.GetMainWeapons() )
		{
			int weaponMax = weapon.GetWeaponPrimaryClipCountMax()
			int ammo = weapon.GetWeaponPrimaryClipCount()
			
			if ( ammo < weaponMax )
				weapon.SetWeaponPrimaryClipCount( minint( weaponMax, ammo + 5 ) )
		}
		
		if( player.IsTitan() )
		{
			foreach ( weapon in player.GetOffhandWeapons() )
			{
				int weaponMax = weapon.GetWeaponPrimaryClipCountMax()
				int ammo = weapon.GetWeaponPrimaryClipCount()
				if ( ammo < weaponMax )
					weapon.SetWeaponPrimaryClipCount( minint( weaponMax, ammo + 5 ) )
			}
		}
		
		else
		{
			entity grenadeweap = player.GetOffhandWeapon( OFFHAND_ORDNANCE )
			if( IsValid( grenadeweap ) )
			{
				int weaponMax = grenadeweap.GetWeaponPrimaryClipCountMax()
				int ammo = grenadeweap.GetWeaponPrimaryClipCount()
				if ( ammo < weaponMax )
					grenadeweap.SetWeaponPrimaryClipCount( minint( weaponMax, ammo + 5 ) )
			}
		}
		
		PlayerEarnMeter_AddOwnedFrac( player, 0.01 )
		WaitFrame()
	}
}